""" loopy instructions to mark stages of computations """

from dune.perftool.generation import noop_instruction


def stage_insn(n, **kwargs):
    assert 'id' not in kwargs

    # Get an ID for this instruction
    id = 'stage_insn_{}'.format(n)

    # Chain dependencies of stage instructions
    if n > 0:
        kwargs['depends_on'] = kwargs.get('depends_on', frozenset([])).union(frozenset([stage_insn(n-1, **kwargs)]))

    # Actually issue the instruction
    noop_instruction(id=id, **kwargs)

    return id
